diff --git a/README.md b/README.md
index f395e49..bda7252 100644
--- a/README.md
+++ b/README.md
@@ -320,6 +320,7 @@ You don't have to do anything manually!
1. Loopia.se API
1. acme-dns (https://github.com/joohoi/acme-dns)
1. TELE3 (https://www.tele3.cz)
+1. EUSERV.EU (https://www.euserv.eu)
And:
diff --git a/dnsapi/README.md b/dnsapi/README.md
index 49f2625..1f394f9 100644
--- a/dnsapi/README.md
+++ b/dnsapi/README.md
@@ -876,7 +876,7 @@ acme.sh --issue --dns dns_tele3 -d example.com -d *.example.com
```
The TELE3_Key and TELE3_Secret will be saved in ~/.acme.sh/account.conf and will be reused when needed.
-## 47. euserv.eu API to automatically issue cert
+## 47. Use Euserv.eu API
First you need to login to your euserv.eu account and activate your API Administration (API Verwaltung).
[https://support.euserv.com](https://support.euserv.com)
@@ -884,14 +884,12 @@ First you need to login to your euserv.eu account and activate your API Administ
Once you've activate, login to your API Admin Interface and create an API account.
Please specify the scope (active groups: domain) and assign the allowed IPs.
-Be aware to use the `--insecure` flag, cause euserv.eu is still using self-signed certificates!
-
```
export EUSERV_Username="99999.user123"
export EUSERV_Password="Asbe54gHde"
```
-Ok, let's issue a cert now:
+Ok, let's issue a cert now: (Be aware to use the `--insecure` flag, cause euserv.eu is still using self-signed certificates!)
```
acme.sh --issue --dns dns_euserv -d example.com -d *.example.com --insecure
```
diff --git a/dnsapi/dns_euserv.sh b/dnsapi/dns_euserv.sh
index 1a58df5..cb1e0a4 100644
--- a/dnsapi/dns_euserv.sh
+++ b/dnsapi/dns_euserv.sh
@@ -42,11 +42,12 @@ dns_euserv_add() {
_err "invalid domain"
return 1
fi
- _debug _sub_domain "$_sub_domain"
- _debug _domain "$_domain"
-
+ _debug "_sub_domain" "$_sub_domain"
+ _debug "_domain" "$_domain"
_info "Adding record"
- _euserv_add_record "$_domain" "$_sub_domain" "$txtvalue"
+ if ! _euserv_add_record "$_domain" "$_sub_domain" "$txtvalue"; then
+ return 1
+ fi
}
@@ -114,24 +115,20 @@ dns_euserv_rm() {
export _H1="Content-Type: text/xml"
response="$(_post "$xml_content" "$EUSERV_Api" "" "POST")"
- ok="$(printf '%s' "$response" | grep "status100")"
- if [ -z "$ok" ]; then
- _err "Error could not get txt records"
+ if ! _contains "$response" "status100"; then
+ _err "Error could not get txt records"
_debug "xml_content" "$xml_content"
_debug "response" "$response"
return 1
fi
-# _startLine=$(printf '%s' "$_euserv_domain_orders" | grep -n '>domain_name<.*>'"$domain"'<' | cut -d ':' -f 1 )
-# _euserv_domain_id=$(printf '%s' "$_euserv_domain_orders" | sed -n "$_startLine"',$p' | grep '>domain_id<' | head -n 1 | sed 's/.*\([0-9]*\)<\/i4>.*/\1/' )
-
if ! printf "%s" "$response" | grep '>dns_record_content<.*>'"$txtvalue"'<' >/dev/null; then
_info "Do not need to delete record"
else
- # find block where txtvalue is in. the record_id is allways prior this line!
- _endLine=$(printf '%s' "$response" | grep -n '>dns_record_content<.*>'"$txtvalue"'<' | cut -d ':' -f 1 )
- # record_id is the last entry with a number, identified by the postfix of
- _record_id=$(printf '%s' "$response" | sed -n '1,'"$_endLine"'p' | grep '' | tail -n 1 | sed 's/.*\([0-9]*\)<\/name>.*/\1/' )
+ # find XML block where txtvalue is in. The record_id is allways prior this line!
+ _endLine=$(printf '%s' "$response" | grep -n '>dns_record_content<.*>'"$txtvalue"'<' | cut -d ':' -f 1 )
+ # record_id is the last Tag with a number before the row _endLine, identified by
+ _record_id=$(printf '%s' "$response" | sed -n '1,'"$_endLine"'p' | grep '' | tail -n 1 | sed 's/.*\([0-9]*\)<\/name>.*/\1/' )
_info "Deleting record"
_euserv_delete_record "$_record_id"
fi
@@ -140,11 +137,52 @@ dns_euserv_rm() {
#################### Private functions below ##################################
+_get_root() {
+ domain=$1
+ _debug "get root"
+
+ # Just to read the domain_orders once
+
+ domain=$1
+ i=2
+ p=1
+
+ if ! _euserv_get_domain_orders; then
+ return 1
+ fi
+
+ # Get saved response with domain_orders
+ response="$_euserv_domain_orders"
+
+ while true; do
+ h=$(printf "%s" "$domain" | cut -d . -f $i-100)
+ _debug h "$h"
+ if [ -z "$h" ]; then
+ #not valid
+ return 1
+ fi
+
+ if _contains "$response" "$h"; then
+ _sub_domain=$(printf "%s" "$domain" | cut -d . -f 1-$p)
+ _domain="$h"
+ if ! _euserv_get_domain_id "$_domain"; then
+ _err "invalid domain"
+ return 1
+ fi
+ return 0
+ fi
+ p=$i
+ i=$(_math "$i" + 1)
+ done
+
+ return 1
+}
+
_euserv_get_domain_orders() {
-# returns: _euserv_domain_orders
+ # returns: _euserv_domain_orders
_debug "get domain_orders"
-
+
xml_content=$(printf '
domain.get_domain_orders
@@ -165,76 +203,41 @@ _euserv_get_domain_orders() {
' "$EUSERV_Username" "$EUSERV_Password")
-
+
export _H1="Content-Type: text/xml"
response="$(_post "$xml_content" "$EUSERV_Api" "" "POST")"
-
- ok="$(printf '%s' "$response" | grep "status100")"
- if [ -z "$ok" ]; then
+
+ if ! _contains "$response" "status100"; then
_err "Error could not get domain orders"
_debug "xml_content" "$xml_content"
_debug "response" "$response"
return 1
fi
-
+
+ # save response to reduce API calls
_euserv_domain_orders="$response"
return 0
}
_euserv_get_domain_id() {
-# returns: _euserv_domain_id
+ # returns: _euserv_domain_id
domain=$1
_debug "get domain_id"
- _startLine=$(printf '%s' "$_euserv_domain_orders" | grep -n '>domain_name<.*>'"$domain"'<' | cut -d ':' -f 1 )
- _euserv_domain_id=$(printf '%s' "$_euserv_domain_orders" | sed -n "$_startLine"',$p' | grep '>domain_id<' | head -n 1 | sed 's/.*\([0-9]*\)<\/i4>.*/\1/' )
+ # find line where the domain name is within the $response
+ _startLine=$(printf '%s' "$_euserv_domain_orders" | grep -n '>domain_name<.*>'"$domain"'<' | cut -d ':' -f 1)
+ # next occurency of domain_id after the domain_name is the correct one
+ _euserv_domain_id=$(printf '%s' "$_euserv_domain_orders" | sed -n "$_startLine"',$p' | grep '>domain_id<' | head -n 1 | sed 's/.*\([0-9]*\)<\/i4>.*/\1/')
- if [ -z "$_euserv_domain_id" ] ; then
+ if [ -z "$_euserv_domain_id" ]; then
_err "Could not find domain_id for domain $domain"
_debug "_euserv_domain_orders" "$_euserv_domain_orders"
return 1
fi
- return 0
-
-}
-
-_get_root() {
- domain=$1
- _debug "get root"
-
- # Just to read the domain_orders once
-
- domain=$1
- i=2
- p=1
- _euserv_get_domain_orders
- response="$_euserv_domain_orders"
-
- while true; do
- h=$(printf "%s" "$domain" | cut -d . -f $i-100)
- _debug h "$h"
- if [ -z "$h" ]; then
- #not valid
- return 1
- fi
-
- if _contains "$response" "$h"; then
- _sub_domain=$(printf "%s" "$domain" | cut -d . -f 1-$p)
- _domain="$h"
- if ! _euserv_get_domain_id "$_domain"; then
- _err "invalid domain"
- return 1
- fi
- return 0
- fi
- p=$i
- i=$(_math "$i" + 1)
- done
- return 1
+ return 0
}
-# TODO
_euserv_delete_record() {
record_id=$1
xml_content=$(printf '
@@ -271,14 +274,13 @@ _euserv_delete_record() {
export _H1="Content-Type: text/xml"
response="$(_post "$xml_content" "$EUSERV_Api" "" "POST")"
- ok="$(printf '%s' "$response" | grep "status100")"
- if [ -z "$ok" ]; then
+ if ! _contains "$response" "status100"; then
_err "Error deleting record"
_debug "xml_content" "$xml_content"
_debug "response" "$response"
return 1
fi
-
+
return 0
}
@@ -340,19 +342,17 @@ _euserv_add_record() {
- ' "$EUSERV_Username" "$EUSERV_Password" "$_euserv_domain_id" "$sub_domain" "$txtval" )
+ ' "$EUSERV_Username" "$EUSERV_Password" "$_euserv_domain_id" "$sub_domain" "$txtval")
export _H1="Content-Type: text/xml"
response="$(_post "$xml_content" "$EUSERV_Api" "" "POST")"
- ok="$(printf '%s' "$response" | grep "status100")"
- if [ -z "$ok" ]; then
+ if ! _contains "$response" "status100"; then
_err "Error could not create record"
_debug "xml_content" "$xml_content"
_debug "response" "$response"
return 1
fi
-# _dns_record_id="$(echo "$response" | _egrep_o "[\s\S]dns_record_id<\/name>[\s]*?[\s]*?(\K\d*)")"
-# _debug "_dns_record_id" "$_dns_record_id"
+
return 0
}